package dev.shadowsoffire.apotheosis.adventure.affix.trades;

import net.minecraft.util.ExtraCodecs;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.kinds.App;
import dev.shadowsoffire.apotheosis.adventure.loot.AffixLootRegistry;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.json.ItemAdapter;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import javax.annotation.Nullable;
import net.minecraft.world.entity.player.Player;
import net.minecraft.util.random.WeightedRandom;
import net.minecraft.util.random.WeightedEntry;
import java.util.function.Predicate;
import java.util.Objects;
import java.util.function.Function;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import net.minecraft.world.level.ServerLevelAccessor;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import net.minecraft.world.item.trading.MerchantOffer;
import net.minecraft.util.RandomSource;
import net.minecraft.world.entity.Entity;
import dev.shadowsoffire.apotheosis.adventure.loot.AffixLootEntry;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.List;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityClamp;
import net.minecraft.world.item.ItemStack;
import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.village.wanderer.JsonTrade;

public class AffixTrade implements JsonTrade
{
    public static final Codec<AffixTrade> CODEC;
    protected final ItemStack price;
    protected final ItemStack price2;
    protected final RarityClamp.Simple rarities;
    protected final List<DynamicHolder<AffixLootEntry>> entries;
    protected final boolean rare;
    
    public AffixTrade(final ItemStack price, final ItemStack price2, final RarityClamp.Simple rarities, final List<DynamicHolder<AffixLootEntry>> entries, final boolean rare) {
        this.price = price;
        this.price2 = price2;
        this.rarities = rarities;
        this.entries = entries;
        this.rare = rare;
    }
    
    @Nullable
    public MerchantOffer m_213663_(final Entity trader, final RandomSource rand) {
        if (trader.m_9236_().f_46443_) {
            return null;
        }
        final Player player = trader.m_9236_().m_45930_(trader, -1.0);
        if (player == null) {
            return null;
        }
        ItemStack affixItem;
        if (this.entries.isEmpty()) {
            final LootRarity selectedRarity = LootRarity.random(rand, player.m_36336_(), (RarityClamp)this.rarities);
            affixItem = LootController.createRandomLootItem(rand, selectedRarity, player, (ServerLevelAccessor)trader.m_9236_());
        }
        else {
            final List<WeightedEntry.Wrapper<AffixLootEntry>> resolved = this.entries.stream().map((Function<? super Object, ?>)this::unwrap).filter(Objects::nonNull).map(e -> e.wrap(player.m_36336_())).toList();
            final AffixLootEntry entry = (AffixLootEntry)WeightedRandom.m_216822_(rand, (List)resolved).get().m_146310_();
            final LootRarity selectedRarity2 = LootRarity.random(rand, player.m_36336_(), (RarityClamp)((this.rarities == RarityClamp.UNCLAMPED) ? entry : this.rarities));
            affixItem = LootController.createLootItem(entry.getStack().m_41777_(), selectedRarity2, rand);
        }
        if (affixItem.m_41619_()) {
            return null;
        }
        affixItem.m_41783_().m_128379_("apoth_merchant", true);
        return new MerchantOffer(this.price, this.price2, affixItem, 1, 100, 1.0f);
    }
    
    public boolean isRare() {
        return this.rare;
    }
    
    public Codec<? extends JsonTrade> getCodec() {
        return (Codec<? extends JsonTrade>)AffixTrade.CODEC;
    }
    
    private AffixLootEntry unwrap(final DynamicHolder<AffixLootEntry> holder) {
        if (!holder.isBound()) {
            AdventureModule.LOGGER.error("An AffixTrade failed to resolve the Affix Loot Entry {}!", (Object)holder.getId());
            return null;
        }
        return (AffixLootEntry)holder.get();
    }
    
    static {
        CODEC = ExtraCodecs.m_184415_(() -> RecordCodecBuilder.create(inst -> inst.group((App)ItemAdapter.CODEC.fieldOf("input_1").forGetter(a -> a.price), (App)PlaceboCodecs.nullableField(ItemAdapter.CODEC, "input_2", (Object)ItemStack.f_41583_).forGetter(a -> a.price2), (App)PlaceboCodecs.nullableField(RarityClamp.Simple.CODEC, "rarities", (Object)RarityClamp.UNCLAMPED).forGetter(a -> a.rarities), (App)AffixLootRegistry.INSTANCE.holderCodec().listOf().fieldOf("entries").forGetter(a -> a.entries), (App)PlaceboCodecs.nullableField((Codec)Codec.BOOL, "rare", (Object)false).forGetter(a -> a.rare)).apply((Applicative)inst, AffixTrade::new)));
    }
}
